# eric3.Utilities.ClassBrowsers.ClbrBaseClasses

Module implementing base classes used by the various class browsers.

### Classes

Attribute | Class to represent an attribute.
Class | Class to represent a class.
ClbrBase | Class implementing the base of all complex class browser objects.
ClbrVisibilityMixinBase | Class implementing the base class of all visibility mixins.
Function | Class to represent a function or method.
Module | Class to represent a module.
_ClbrBase | Class implementing the base of all class browser objects.

### Functions

None

## Attribute

Class to represent an attribute.

### Derived from

_ClbrBase

### Methods

Attribute | Constructor

### Attribute (Constructor)

Attribute(name)

Constructor

name
  name of this attribute

Up

## Class

Class to represent a class.

### Derived from

ClbrBase

### Methods

Class | Constructor

### Class (Constructor)

Class(module, name, super, file, lineno)

Constructor

module
  name of the module containing this class
name
  name of this class
super
  list of class names this class is inherited from
file
  filename containing this class
lineno
  linenumber of the class definition

Up

## ClbrBase

Class implementing the base of all complex class browser objects.

### Derived from

_ClbrBase

### Methods

ClbrBase | Constructor
_addattribute | Method to add information about attributes.
_addclass | Protected method to add a nested class to this class.
_addmethod | Method to add information about a method.
_getattribute | Method to retrieve an attribute by name.
_getmethod | Method to retrieve a method by name.

### ClbrBase (Constructor)

ClbrBase(module, name, file, lineno)

Constructor

module
  name of the module containing this class
name
  name of this class
file
  filename containing this class
lineno
  linenumber of the class definition

### ClbrBase._addattribute

_addattribute(attr)

Method to add information about attributes.

attr
  Attribute object to be added (string)

### ClbrBase._addclass

_addclass(name, _class)

Protected method to add a nested class to this class.

name
  name of the class
_class
  Class object to be added

### ClbrBase._addmethod

_addmethod(name, function)

Method to add information about a method.

name
  name of method to be added (string)
function
  Function object to be added

### ClbrBase._getattribute

_getattribute(name)

Method to retrieve an attribute by name.

name
  name of the attribute (string)

Returns:
  the named attribute or None

### ClbrBase._getmethod

_getmethod(name)

Method to retrieve a method by name.

name
  name of the method (string)

Returns:
  the named method or None

Up

## ClbrVisibilityMixinBase

Class implementing the base class of all visibility mixins.

### Derived from

None

### Methods

isPrivate | Method to check, if the visibility is Private.
isProtected | Method to check, if the visibility is Protected.
isPublic | Method to check, if the visibility is Public.
setPrivate | Method to set the visibility to Private.
setProtected | Method to set the visibility to Protected.
setPublic | Method to set the visibility to Public.

### ClbrVisibilityMixinBase.isPrivate

isPrivate()

Method to check, if the visibility is Private.

Returns:
  flag indicating Private visibility (boolean)

### ClbrVisibilityMixinBase.isProtected

isProtected()

Method to check, if the visibility is Protected.

Returns:
  flag indicating Protected visibility (boolean)

### ClbrVisibilityMixinBase.isPublic

isPublic()

Method to check, if the visibility is Public.

Returns:
  flag indicating Public visibility (boolean)

### ClbrVisibilityMixinBase.setPrivate

setPrivate()

Method to set the visibility to Private.

### ClbrVisibilityMixinBase.setProtected

setProtected()

Method to set the visibility to Protected.

### ClbrVisibilityMixinBase.setPublic

setPublic()

Method to set the visibility to Public.

Up

## Function

Class to represent a function or method.

### Derived from

ClbrBase

### Methods

Function | Constructor

### Function (Constructor)

Function(module, name, file, lineno, signature = '', separator = ', ')

Constructor

module
  name of the module containing this function
name
  name of this function
file
  filename containing this class
lineno
  linenumber of the class definition
signature
  parameterlist of the method
separator
  string separating the parameters

Up

## Module

Class to represent a module.

### Derived from

ClbrBase

### Methods

Module | Constructor

### Module (Constructor)

Module(module, name, file, lineno)

Constructor

module
  name of the module containing this class
name
  name of this class
file
  filename containing this class
lineno
  linenumber of the class definition

Up

## _ClbrBase

Class implementing the base of all class browser objects.

### Derived from

None

### Methods

_ClbrBase | Constructor

### _ClbrBase (Constructor)

_ClbrBase(module, name, file, lineno)

Constructor

module
  name of the module containing this class
name
  name of this class
file
  filename containing this class
lineno
  linenumber of the class definition

Up